var AJAX_REPLACE_CONTENT = 'replaceContent';
var AJAX_REDIRECT = 'redirect'; 

function makeRequest(url,instanceName,paramsAjax,directUpdate) {
    /*if (directUpdate == 'undefined')
      directUpdate = false;*/
    paramsAjax = paramsAjax + '&htmlId=' + instanceName;
    if (directUpdate) {
        paramsAjax = paramsAjax + '&directUpdate=1';
        var myAjax = new Ajax.Updater(instanceName, 
                                      url, 
                                      {method: 'post', parameters : paramsAjax, evalScripts: true});
    }
    else
        var myAjax = new Ajax.Request(url, {method: 'post', parameters : paramsAjax, onComplete: onResponse});
}

function onResponse(originalRequest) {
    response = originalRequest.responseXML;
    // Tests pour Mozilla
    if (response == null) {
        badResponse(originalRequest.responseText);
		return false;
	}
    // Tests pour IE
    if (response.documentElement == null) {
        badResponse(originalRequest.responseText);
		return false;
	}
    // Element DOM correspondant à l'élément <response>
    response = response.documentElement.getElementsByTagName("response")[0];
	responseType = response.getAttribute("type");
	responseValue = response.firstChild.nodeValue;
	if (responseType == AJAX_REDIRECT)
	    redirect(responseValue);
	if (responseType == AJAX_REPLACE_CONTENT) {
        htmlID = response.getAttribute("htmlId");
	    replaceID(htmlID, responseValue);
	}
}

function badResponse(responseText) {
  window.location.reload();
}

function replaceID(htmlID, content) {
    var ScriptFragment = '(?:<script.*?>)((\r|\n|.)*?)(?:<\/script>)';
    var match    = new RegExp(ScriptFragment, 'img');
    var scripts  = content.match(match);
    $(htmlID).innerHTML = content;
    if (scripts) {
        match = new RegExp(ScriptFragment, 'im');
        for (var i = 0; i < scripts.length; i++) {
            if (scripts[i].match(match)[1]) {
            eval(scripts[i].match(match)[1]);
            }
        }
    }
}

function redirect(url) {
    window.location.href=url;
}

function submitRequest(url, form, htmlId, params,directUpdate) {
      makeRequest(url, htmlId, Form.serialize(form) + '&' + params,directUpdate);
      return false;
}